scala

# Option

###
Related Docs: object Option | package scala

#### sealed abstract class Option[+A] extends Product with Serializable

Represents optional values. Instances of `Option` are either an instance of scala.Some or the object `None`.

The most idiomatic way to use an scala.Option instance is to treat it as a collection or monad and use `map`,`flatMap`, `filter`, or `foreach`:

    val name: Option[String] = request getParameter "name"
    val upper = name map { _.trim } filter { _.length != 0 } map { _.toUpperCase }
    println(upper getOrElse "")

Note that this is equivalent to

    val upper = for {
      name <- request getParameter "name"
      trimmed <- Some(name.trim)
      upper <- Some(trimmed.toUpperCase) if trimmed.length != 0
    } yield upper
    println(upper getOrElse "")

Because of how for comprehension works, if `None` is returned from `request.getParameter`, the entire expression results in `None`

This allows for sophisticated chaining of scala.Option values without having to check for the existence of a value.

A less-idiomatic way to use scala.Option values is via pattern matching:

    val nameMaybe = request getParameter "name"
    nameMaybe match {
      case Some(name) =>
        println(name.trim.toUppercase)
      case None =>
        println("No name value")
    }

Self Type
  Option[A]
Annotations
  @SerialVersionUID()
Source
  Option.scala
Version

  1.1, 16/01/2007

Note

  Many of the methods in here are duplicative with those in the Traversable hierarchy, but they are duplicated for a reason: the implicit conversion tends to leave one with an Iterable in situations where one could have retained an Option.

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, AnyRef, Any
Known Subclasses
None, Some
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Option
2. Serializable
3. Serializable
4. Product
5. Equals
6. AnyRef
7. Any

Implicitly

1. by option2Iterable
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1. #### class WithFilter extends AnyRef

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

### Abstract Value Members

1. #### abstract def canEqual(that: Any): Boolean

   A method that should be called from every well-designed equals method that is open to be overridden in a subclass.

   A method that should be called from every well-designed equals method that is open to be overridden in a subclass. See Programming in Scala, Chapter 28 for discussion and design.

   that

     the value being probed for possible equality

   returns

     true if this instance can possibly equal `that`, otherwise false

   Definition Classes
     Equals

2. #### abstract def get: A

   Returns the option's value.

   Returns the option's value.

   Exceptions thrown

     `java.util.NoSuchElementException` if the option is empty.

   Note

     The option must be nonEmpty.

3. #### abstract def isEmpty: Boolean

   Returns true if the option is `None`, false otherwise.

4. #### abstract def productArity: Int

   The size of this product.

   The size of this product.

   returns

     for a product `A(x1, ..., xk)`, returns `k`

   Definition Classes
     Product

5. #### abstract def productElement(n: Int): Any

   The nth element of this product, 0-based.

   The nth element of this product, 0-based. In other words, for a product `A(x1, ..., xk)`, returns `x(n+1)` where `0 < n < k`.

   n

     the index of the element to return

   returns

     the element `n` elements after the first element

   Definition Classes
     Product
   Exceptions thrown

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Option[A] to any2stringadd[Option[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ++[B](that: GenTraversableOnce[B]): Option[B]

   [use case] Returns a new option containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new option containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the option is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = List(1)
       a: List[Int] = List(1)

       scala> val b = List(2)
       b: List[Int] = List(2)

       scala> val c = a ++ b
       c: List[Int] = List(1, 2)

       scala> val d = List('a')
       d: List[Char] = List(a)

       scala> val e = c ++ d
       e: List[AnyVal] = List(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new option which contains all elements of this option followed by all elements of `that`.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

5. #### def ++:[B >: A, That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this iterable collection followed by all elements of `that`.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Definition Classes
     TraversableLike

6. #### def ++:[B](that: collection.TraversableOnce[B]): Option[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new option which contains all elements of this option followed by all elements of `that`.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: A, That](that: collection.TraversableOnce[B])(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

7. #### def ->[B](y: B): (Option[A], B)

   Implicit information
     This member is added by an implicit conversion from Option[A] to ArrowAssoc[Option[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

8. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

   Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this iterable collection, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this iterable collection.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Definition Classes
     TraversableOnce → GenTraversableOnce

9. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

   Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this iterable collection, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this iterable collection.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Definition Classes
     TraversableOnce → GenTraversableOnce

10. #### final def ==(arg0: Any): Boolean

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

11. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this iterable collection to a string builder.

    Appends all elements of this iterable collection to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this iterable collection without any separator string.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        h: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce

12. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this iterable collection to a string builder using a separator string.

    Appends all elements of this iterable collection to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this iterable collection, separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce

13. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this iterable collection to a string builder using start, end, and separator strings.

    Appends all elements of this iterable collection to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this iterable collection are separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b , "List(" , ", " , ")")
        res5: StringBuilder = List(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce

14. #### def aggregate[B](z: ⇒ B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It is similar to `foldLeft` in that it doesn't require the result to be a supertype of the element type. In addition, it allows parallel collections to be processed in chunks, and then combines the intermediate results.

    `aggregate` splits the iterable collection into partitions and processes each partition by sequentially applying `seqop`, starting with `z` (like `foldLeft`). Those intermediate results are then combined by using `combop` (like `fold`). The implementation of this operation may operate on an arbitrary number of collection partitions (even 1), so `combop` may be invoked an arbitrary number of times (even 0).

    As an example, consider summing up the integer values of a list of chars. The initial value for the sum is 0. First, `seqop` transforms each input character to an Int and adds it to the sum (of the partition). Then, `combop` just needs to sum up the intermediate results of the partitions:

        List('a', 'b', 'c').aggregate(0)({ (sum, ch) => sum + ch.toInt }, { (p1, p2) => p1 + p2 })

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

15. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

16. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

17. #### final def collect[B](pf: PartialFunction[A, B]): Option[B]

    Returns a scala.Some containing the result of applying `pf` to this scala.Option's contained value, if this option is nonempty and `pf` is defined for that value.

    Returns a scala.Some containing the result of applying `pf` to this scala.Option's contained value, if this option is nonempty and `pf` is defined for that value. Returns `None` otherwise.

    pf

      the partial function.

    returns

      the result of applying `pf` to this scala.Option's value (if possible), or `None`.

    Annotations
      @inline()
    Example:

    1.     // Returns Some(HTTP) because the partial function covers the case.
           Some("http") collect {case "http" => "HTTP"}
           // Returns None because the partial function doesn't cover the case.
           Some("ftp") collect {case "http" => "HTTP"}
           // Returns None because the option is empty. There is no value to pass to the partial function.
           None collect {case value => value}

18. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the iterable collection for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the iterable collection for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

19. #### def companion: GenericCompanion[collection.Iterable]

    The factory companion object that builds instances of class Iterable.

    The factory companion object that builds instances of class Iterable. (or its `Iterable` superclass where class Iterable is not a `Seq`.)

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      Iterable → GenIterable → Traversable → GenTraversable → GenericTraversableTemplate

20. #### final def contains[A1 >: A](elem: A1): Boolean

    Tests whether the option contains a given value as an element.

    Tests whether the option contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if the option has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Example:

    1.     // Returns true because Some instance contains string "something" which equals "something".
           Some("something") contains "something"
           // Returns false because "something" != "anything".
           Some("something") contains "anything"
           // Returns false when method called on None.
           None contains "anything"

21. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies the elements of this option to an array.

    [use case]

    Copies the elements of this option to an array. Fills the given array `xs` with at most `len` elements of this option, starting at position `start`. Copying will stop once either the end of the current option is reached, or the end of the target array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

22. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies the elements of this option to an array.

    [use case]

    Copies the elements of this option to an array. Fills the given array `xs` with values of this option. Copying will stop once either the end of the current option is reached, or the end of the target array is reached.

    xs

      the array to fill.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B]): Unit

23. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies the elements of this option to an array.

    [use case]

    Copies the elements of this option to an array. Fills the given array `xs` with values of this option, beginning at index `start`. Copying will stop once either the end of the current option is reached, or the end of the target array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

24. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this iterable collection to a buffer.

    Copies all elements of this iterable collection to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce

25. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the iterable collection which satisfy a predicate.

    Counts the number of elements in the iterable collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

26. #### def drop(n: Int): collection.Iterable[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this iterable collection.

    returns

      a iterable collection consisting of all elements of this iterable collection except the first `n` ones, or else the empty iterable collection, if this iterable collection has less than `n` elements.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

27. #### def dropRight(n: Int): collection.Iterable[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      The number of elements to take

    returns

      a iterable collection consisting of all elements of this iterable collection except the last `n` ones, or else the empty iterable collection, if this iterable collection has less than `n` elements.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike

28. #### def dropWhile(p: (A) ⇒ Boolean): collection.Iterable[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the longest suffix of this iterable collection whose first element does not satisfy the predicate `p`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

29. #### def ensuring(cond: (Option[A]) ⇒ Boolean, msg: ⇒ Any): Option[A]

    Implicit information
      This member is added by an implicit conversion from Option[A] to Ensuring[Option[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

30. #### def ensuring(cond: (Option[A]) ⇒ Boolean): Option[A]

    Implicit information
      This member is added by an implicit conversion from Option[A] to Ensuring[Option[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

31. #### def ensuring(cond: Boolean, msg: ⇒ Any): Option[A]

    Implicit information
      This member is added by an implicit conversion from Option[A] to Ensuring[Option[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

32. #### def ensuring(cond: Boolean): Option[A]

    Implicit information
      This member is added by an implicit conversion from Option[A] to Ensuring[Option[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

33. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

34. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

35. #### final def exists(p: (A) ⇒ Boolean): Boolean

    Returns true if this option is nonempty and the predicate `p` returns true when applied to this scala.Option's value.

    Returns true if this option is nonempty and the predicate `p` returns true when applied to this scala.Option's value. Otherwise, returns false.

    p

      the predicate to test

    Annotations
      @inline()

36. #### final def filter(p: (A) ⇒ Boolean): Option[A]

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns true.

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns true. Otherwise, return `None`.

    p

      the predicate used for testing.

    Annotations
      @inline()

37. #### final def filterNot(p: (A) ⇒ Boolean): Option[A]

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns false.

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns false. Otherwise, return `None`.

    p

      the predicate used for testing.

    Annotations
      @inline()

38. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the iterable collection that satisfies `p`, or `None` if none exists.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

39. #### final def flatMap[B](f: (A) ⇒ Option[B]): Option[B]

    Returns the result of applying `f` to this scala.Option's value if this scala.Option is nonempty.

    Returns the result of applying `f` to this scala.Option's value if this scala.Option is nonempty. Returns `None` if this scala.Option is empty. Slightly different from `map` in that `f` is expected to return an scala.Option (which could be `None`).

    f

      the function to apply

    Annotations
      @inline()
    See also

      foreach

      map

40. #### def flatten[B](implicit ev: <:<[A, Option[B]]): Option[B]

41. #### final def fold[B](ifEmpty: ⇒ B)(f: (A) ⇒ B): B

    Returns the result of applying `f` to this scala.Option's value if the scala.Option is nonempty.

    Returns the result of applying `f` to this scala.Option's value if the scala.Option is nonempty. Otherwise, evaluates expression `ifEmpty`.

    ifEmpty

      the expression to evaluate if empty.

    f

      the function to apply if nonempty.

    Annotations
      @inline()
    Note

      This is equivalent to `scala.Option map f getOrElse ifEmpty`.

42. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

    Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this iterable collection. Returns `z` if this iterable collection is empty.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

43. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this iterable collection. Returns `z` if this iterable collection is empty.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

44. #### final def forall(p: (A) ⇒ Boolean): Boolean

    Returns true if this option is empty or the predicate `p` returns true when applied to this scala.Option's value.

    Returns true if this option is empty or the predicate `p` returns true when applied to this scala.Option's value.

    p

      the predicate to test

    Annotations
      @inline()

45. #### final def foreach[U](f: (A) ⇒ U): Unit

    Apply the given procedure `f` to the option's value, if it is nonempty.

    Apply the given procedure `f` to the option's value, if it is nonempty. Otherwise, do nothing.

    f

      the procedure to apply.

    Annotations
      @inline()
    See also

      flatMap

      map

46. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Option[A] to StringFormat[Option[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

47. #### def genericBuilder[B]: Builder[B, collection.Iterable[B]]

    The generic builder that builds instances of Iterable at arbitrary element types.

    The generic builder that builds instances of Iterable at arbitrary element types.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      GenericTraversableTemplate

48. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

49. #### final def getOrElse[B >: A](default: ⇒ B): B

    Returns the option's value if the option is nonempty, otherwise return the result of evaluating `default`.

    Returns the option's value if the option is nonempty, otherwise return the result of evaluating `default`.

    default

      the default expression.

    Annotations
      @inline()

50. #### def groupBy[K](f: (A) ⇒ K): Map[K, collection.Iterable[A]]

    Partitions this iterable collection into a map of iterable collections according to some discriminator function.

    Partitions this iterable collection into a map of iterable collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new iterable collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to iterable collections such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a iterable collection of those elements `x` for which `f(x)` equals `k`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

51. #### def grouped(size: Int): collection.Iterator[collection.Iterable[A]]

    Partitions elements in fixed size iterable collections.

    Partitions elements in fixed size iterable collections.

    size

      the number of elements per group

    returns

      An iterator producing iterable collections of size `size`, except the last will be less than size `size` if the elements don't divide evenly.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

52. #### def hasDefiniteSize: Boolean

    Tests whether this iterable collection is known to have a finite size.

    Tests whether this iterable collection is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

    Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

53. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()

54. #### def head: A

    Selects the first element of this iterable collection.

    Selects the first element of this iterable collection.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` if the iterable collection is empty.

55. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this iterable collection if it is nonempty, `None` if it is empty.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

56. #### def init: collection.Iterable[A]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a iterable collection consisting of all elements of this iterable collection except the last one.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the iterable collection is empty.

57. #### def inits: collection.Iterator[collection.Iterable[A]]

    Iterates over the inits of this iterable collection.

    Iterates over the inits of this iterable collection. The first value will be this iterable collection and the final one will be an empty iterable collection, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this iterable collection

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

58. #### def isDefined: Boolean

    Returns true if the option is an instance of scala.Some, false otherwise.

59. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

60. #### final def isTraversableAgain: Boolean

    Tests whether this iterable collection can be repeatedly traversed.

    Tests whether this iterable collection can be repeatedly traversed.

    returns

      `true`

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike → GenTraversableOnce

61. #### def iterator: Iterator[A]

    Returns a singleton iterator returning the scala.Option's value if it is nonempty, or an empty iterator if the option is empty.

62. #### def last: A

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the iterable collection is empty.

63. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this iterable collection$ if it is nonempty, `None` if it is empty.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

64. #### final def map[B](f: (A) ⇒ B): Option[B]

    Returns a scala.Some containing the result of applying `f` to this scala.Option's value if this scala.Option is nonempty.

    Returns a scala.Some containing the result of applying `f` to this scala.Option's value if this scala.Option is nonempty. Otherwise return `None`.

    f

      the function to apply

    Annotations
      @inline()
    Note

      This is similar to `flatMap` except here, `f` does not need to wrap its result in an scala.Option.

    See also

      foreach

      flatMap

65. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this option.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def max[B >: A](implicit cmp: Ordering[B]): A

66. #### def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this option with the largest value measured by function f.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

67. #### def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this option

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def min[B >: A](implicit cmp: Ordering[B]): A

68. #### def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this option with the smallest value measured by function f.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

69. #### def mkString: String

    Displays all elements of this iterable collection in a string.

    Displays all elements of this iterable collection in a string.

    returns

      a string representation of this iterable collection. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this iterable collection follow each other without any separator string.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

70. #### def mkString(sep: String): String

    Displays all elements of this iterable collection in a string using a separator string.

    Displays all elements of this iterable collection in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this iterable collection. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this iterable collection are separated by the string `sep`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

71. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this iterable collection in a string using start, end, and separator strings.

    Displays all elements of this iterable collection in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this iterable collection. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this iterable collection are separated by the string `sep`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

72. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

73. #### final def nonEmpty: Boolean

    Returns false if the option is `None`, true otherwise.

    Returns false if the option is `None`, true otherwise.

    Note

      Implemented here to avoid the implicit conversion to Iterable.

74. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

75. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

76. #### final def orElse[B >: A](alternative: ⇒ Option[B]): Option[B]

    Returns this scala.Option if it is nonempty, otherwise return the result of evaluating `alternative`.

    Returns this scala.Option if it is nonempty, otherwise return the result of evaluating `alternative`.

    alternative

      the alternative expression.

    Annotations
      @inline()

77. #### final def orNull[A1 >: A](implicit ev: <:<[Null, A1]): A1

    Returns the option's value if it is nonempty, or `null` if it is empty.

    Returns the option's value if it is nonempty, or `null` if it is empty. Although the use of null is discouraged, code written to use scala.Option must often interface with code that expects and returns nulls.

    Annotations
      @inline()
    Example:

    1.     val initialText: Option[String] = getInitialText
           val textField = new JComponent(initialText.orNull,20)

78. #### def par: ParIterable[A]

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      Parallelizable

79. #### def partition(p: (A) ⇒ Boolean): (collection.Iterable[A], collection.Iterable[A])

    Partitions this iterable collection in two iterable collections according to a predicate.

    Partitions this iterable collection in two iterable collections according to a predicate.

    p

      the predicate on which to partition.

    returns

      a pair of iterable collections: the first iterable collection consists of all elements that satisfy the predicate `p` and the second iterable collection consists of all elements that don't. The relative order of the elements in the resulting iterable collections is the same as in the original iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

80. #### def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this option of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the option and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def product[B >: A](implicit num: Numeric[B]): B

81. #### def productIterator: Iterator[Any]

    An iterator over all the elements of this product.

    An iterator over all the elements of this product.

    returns

      in the default implementation, an `Iterator[Any]`

    Definition Classes
      Product

82. #### def productPrefix: String

    A string used in the `toString` methods of derived classes.

    A string used in the `toString` methods of derived classes. Implementations may override this method to prepend a string prefix to the result of `toString` methods.

    returns

      in the default implementation, the empty string

    Definition Classes
      Product

83. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this iterable collection using the specified associative binary operator.

    Reduces the elements of this iterable collection using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the iterable collection is nonempty.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this iterable collection is empty.

84. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection, going left to right.

    Applies a binary operator to all elements of this iterable collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going left to right:

          op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

      where `x1, ..., xn` are the elements of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this iterable collection is empty.

85. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this iterable collection, going left to right.

    Optionally applies a binary operator to all elements of this iterable collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` if this iterable collection is nonempty, `None` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

86. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this iterable collection, if any, using the specified associative binary operator.

    Reduces the elements of this iterable collection, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

87. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection, going right to left.

    Applies a binary operator to all elements of this iterable collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this iterable collection is empty.

88. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this iterable collection, going right to left.

    Optionally applies a binary operator to all elements of this iterable collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` if this iterable collection is nonempty, `None` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

89. #### def repr: collection.Iterable[A]

    The collection of type iterable collection underlying this `TraversableLike` object.

    The collection of type iterable collection underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

90. #### def sameElements(that: GenIterable[A]): Boolean

    [use case] Checks if the other iterable collection contains the same elements in the same order as this option.

    [use case]

    Checks if the other iterable collection contains the same elements in the same order as this option.

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → GenIterableLike
    Full Signature

    #### def sameElements[B >: A](that: GenIterable[B]): Boolean

91. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[collection.Iterable[A], B, That]): That

    Computes a prefix scan of the elements of the collection.

    Computes a prefix scan of the elements of the collection.

    Note: The neutral element `z` may be applied more than once.

    B

      element type of the resulting collection

    That

      type of the resulting collection

    z

      neutral element for the operator `op`

    op

      the associative operator for the scan

    cbf

      combiner factory which provides a combiner

    returns

      a new iterable collection containing the prefix scan of the elements in this iterable collection

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

92. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

    Produces a collection containing cumulative results of applying the operator going left to right.

    Produces a collection containing cumulative results of applying the operator going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    B

      the type of the elements in the resulting collection

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      collection with intermediate results

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

93. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

    Produces a collection containing cumulative results of applying the operator going right to left.

    Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Example:

        List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

    B

      the type of the elements in the resulting collection

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      collection with intermediate results

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike
    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

94. #### def seq: collection.Iterable[A]

    A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

    A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

    This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

    returns

      a sequential view of the collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      Iterable → GenIterable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

95. #### def size: Int

    The size of this iterable collection.

    The size of this iterable collection.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableOnce → GenTraversableOnce

96. #### def slice(from: Int, until: Int): collection.Iterable[A]

    Selects an interval of elements.

    Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

        from <= indexOf(x) < until

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a iterable collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

97. #### def sliding(size: Int, step: Int): collection.Iterator[collection.Iterable[A]]

    Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

    Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

    size

      the number of elements per group

    step

      the distance between the first elements of successive groups

    returns

      An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `sliding`

98. #### def sliding(size: Int): collection.Iterator[collection.Iterable[A]]

    Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

    Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

    size

      the number of elements per group

    returns

      An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `sliding`

99. #### def span(p: (A) ⇒ Boolean): (collection.Iterable[A], collection.Iterable[A])

    Splits this iterable collection into a prefix/suffix pair according to a predicate.

    Splits this iterable collection into a prefix/suffix pair according to a predicate.

    Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a pair consisting of the longest prefix of this iterable collection whose elements all satisfy `p`, and the rest of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Definition Classes
      TraversableLike → GenTraversableLike

100. #### def splitAt(n: Int): (collection.Iterable[A], collection.Iterable[A])

     Splits this iterable collection into two at a given position.

     Splits this iterable collection into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of iterable collections consisting of the first `n` elements of this iterable collection, and the other elements.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableLike → GenTraversableLike

101. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this iterable collection. By default the string prefix is the simple name of the collection class iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableLike → GenTraversableLike

102. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this option of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the option and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: A](implicit num: Numeric[B]): B

103. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

104. #### def tail: collection.Iterable[A]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a iterable collection consisting of all elements of this iterable collection except the first one.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown

       ``UnsupportedOperationException`` if the iterable collection is empty.

105. #### def tails: collection.Iterator[collection.Iterable[A]]

     Iterates over the tails of this iterable collection.

     Iterates over the tails of this iterable collection. The first value will be this iterable collection and the final one will be an empty iterable collection, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this iterable collection

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

106. #### def take(n: Int): collection.Iterable[A]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take from this iterable collection.

     returns

       a iterable collection consisting only of the first `n` elements of this iterable collection, or else the whole iterable collection, if it has less than `n` elements.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

107. #### def takeRight(n: Int): collection.Iterable[A]

     Selects last n elements.

     Selects last n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take

     returns

       a iterable collection consisting only of the last `n` elements of this iterable collection, or else the whole iterable collection, if it has less than `n` elements.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike

108. #### def takeWhile(p: (A) ⇒ Boolean): collection.Iterable[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       the longest prefix of this iterable collection whose elements all satisfy the predicate `p`.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

109. #### def to[Col[_]]: Col[A]

     [use case] Converts this option into another by copying all elements.

     [use case]

     Converts this option into another by copying all elements.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this option.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

110. #### def toArray: Array[A]

     [use case] Converts this option to an array.

     [use case]

     Converts this option to an array.

     returns

       an array containing all elements of this option. An `ClassTag` must be available for the element type of this option.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: A](implicit arg0: ClassTag[B]): Array[B]

111. #### def toBuffer[B >: A]: Buffer[B]

     Uses the contents of this iterable collection to create a new mutable buffer.

     Uses the contents of this iterable collection to create a new mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce

112. #### def toIndexedSeq: collection.immutable.IndexedSeq[A]

     Converts this iterable collection to an indexed sequence.

     Converts this iterable collection to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce

113. #### def toIterable: collection.Iterable[A]

     Returns this iterable collection as an iterable collection.

     Returns this iterable collection as an iterable collection.

     A new collection will not be built; lazy collections will stay lazy.

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

114. #### def toIterator: collection.Iterator[A]

     Returns an Iterator over the elements in this iterable collection.

     Returns an Iterator over the elements in this iterable collection. Produces the same result as `iterator`.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

115. #### final def toLeft[X](right: ⇒ X): Serializable with Product with util.Either[A, X]

     Returns a scala.util.Right containing the given argument `right` if this is empty, or a scala.util.Left containing this scala.Option's value if this scala.Option is nonempty.

     Returns a scala.util.Right containing the given argument `right` if this is empty, or a scala.util.Left containing this scala.Option's value if this scala.Option is nonempty.

     right

       the expression to evaluate and return if this is empty

     Annotations
       @inline()
     See also

       toRight

116. #### def toList: List[A]

     Returns a singleton list containing the scala.Option's value if it is nonempty, or the empty list if the scala.Option is empty.

117. #### def toMap[T, U]: Map[T, U]

     [use case] Converts this option to a map.

     [use case]

     Converts this option to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this option.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

118. #### final def toRight[X](left: ⇒ X): Serializable with Product with util.Either[X, A]

     Returns a scala.util.Left containing the given argument `left` if this scala.Option is empty, or a scala.util.Right containing this scala.Option's value if this is nonempty.

     Returns a scala.util.Left containing the given argument `left` if this scala.Option is empty, or a scala.util.Right containing this scala.Option's value if this is nonempty.

     left

       the expression to evaluate and return if this is empty

     Annotations
       @inline()
     See also

       toLeft

119. #### def toSeq: collection.Seq[A]

     Converts this iterable collection to a sequence.

     Converts this iterable collection to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce

120. #### def toSet[B >: A]: Set[B]

     Converts this iterable collection to a set.

     Converts this iterable collection to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce

121. #### def toStream: collection.immutable.Stream[A]

     Converts this iterable collection to a stream.

     Converts this iterable collection to a stream.

     returns

       a stream containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

122. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       AnyRef → Any

123. #### def toTraversable: collection.Traversable[A]

     Converts this iterable collection to an unspecified Traversable.

     Converts this iterable collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

124. #### def toVector: Vector[A]

     Converts this iterable collection to a Vector.

     Converts this iterable collection to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       TraversableOnce → GenTraversableOnce

125. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): collection.Iterable[collection.Iterable[B]]

     Transposes this iterable collection of traversable collections into a iterable collection of iterable collections.

     Transposes this iterable collection of traversable collections into a iterable collection of iterable collections.

     The resulting collection's type will be guided by the static type of iterable collection. For example:

         val xs = List(
                    Set(1, 2, 3),
                    Set(4, 5, 6)).transpose
         // xs == List(
         //         List(1, 4),
         //         List(2, 5),
         //         List(3, 6))

         val ys = Vector(
                    List(1, 2, 3),
                    List(4, 5, 6)).transpose
         // ys == Vector(
         //         Vector(1, 4),
         //         Vector(2, 5),
         //         Vector(3, 6))

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this iterable collection is a `Traversable`.

     returns

       a two-dimensional iterable collection of iterable collections which has as nth row the nth column of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown

       `IllegalArgumentException` if all collections in this iterable collection are not of the same size.

126. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (collection.Iterable[A1], collection.Iterable[A2])

     Converts this iterable collection of pairs into two collections of the first and second half of each pair.

     Converts this iterable collection of pairs into two collections of the first and second half of each pair.

         val xs = Iterable(
                    (1, "one"),
                    (2, "two"),
                    (3, "three")).unzip
         // xs == (Iterable(1, 2, 3),
         //        Iterable(one, two, three))

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this iterable collection is a pair.

     returns

       a pair of iterable collections, containing the first, respectively second half of each element pair of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       GenericTraversableTemplate

127. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (collection.Iterable[A1], collection.Iterable[A2], collection.Iterable[A3])

     Converts this iterable collection of triples into three collections of the first, second, and third element of each triple.

     Converts this iterable collection of triples into three collections of the first, second, and third element of each triple.

         val xs = Iterable(
                    (1, "one", '1'),
                    (2, "two", '2'),
                    (3, "three", '3')).unzip3
         // xs == (Iterable(1, 2, 3),
         //        Iterable(one, two, three),
         //        Iterable(1, 2, 3))

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this iterable collection is a triple.

     returns

       a triple of iterable collections, containing the first, second, respectively third member of each element triple of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       GenericTraversableTemplate

128. #### def view(from: Int, until: Int): IterableView[A, collection.Iterable[A]]

     Creates a non-strict view of a slice of this iterable collection.

     Creates a non-strict view of a slice of this iterable collection.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current iterable collection, whereas `slice` produces a new iterable collection.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this iterable collection, starting at index `from` and extending up to (but not including) index `until`.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableLike

129. #### def view: IterableView[A, collection.Iterable[A]]

     Creates a non-strict view of this iterable collection.

     Creates a non-strict view of this iterable collection.

     returns

       a non-strict view of this iterable collection.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → TraversableLike

130. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

131. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

132. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

133. #### final def withFilter(p: (A) ⇒ Boolean): WithFilter

     Necessary to keep scala.Option from being implicitly converted to scala.collection.Iterable in `for` comprehensions.

     Necessary to keep scala.Option from being implicitly converted to scala.collection.Iterable in `for` comprehensions.

     Annotations
       @inline()

134. #### def zip[B](that: GenIterable[B]): Option[(A, B)]

     [use case] Returns a option formed from this option and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a option formed from this option and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new option containing pairs consisting of corresponding elements of this option and `that`. The length of the returned collection is the minimum of the lengths of this option and `that`.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[collection.Iterable[A], (A1, B), That]): That

135. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): Option[(A, B)]

     [use case] Returns a option formed from this option and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a option formed from this option and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this option is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this option.

     returns

       a new option containing pairs consisting of corresponding elements of this option and `that`. The length of the returned collection is the maximum of the lengths of this option and `that`. If this option is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this option, `thatElem` values are used to pad the result.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[collection.Iterable[A], (A1, B), That]): That

136. #### def zipWithIndex: Option[(A, Int)]

     [use case] Zips this option with its indices.

     [use case]

     Zips this option with its indices.

     returns

       A new option containing pairs consisting of all elements of this option paired with their index. Indices start at `0`.

     Implicit information
       This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[collection.Iterable[A], (A1, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

137. #### def →[B](y: B): (Option[A], B)

     Implicit information
       This member is added by an implicit conversion from Option[A] to ArrowAssoc[Option[A]] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def canEqual(that: Any): Boolean

   Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

   Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

   that

     The object with which this iterable collection should be compared

   returns

     `true`, if this iterable collection can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).canEqual(that)

   Definition Classes
     IterableLike → Equals

2. #### def collect[B](pf: PartialFunction[A, B]): Option[B]

   [use case] Builds a new collection by applying a partial function to all elements of this option on which the function is defined.

   [use case]

   Builds a new collection by applying a partial function to all elements of this option on which the function is defined.

   B

     the element type of the returned collection.

   pf

     the partial function which filters and maps the option.

   returns

     a new option resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).collect(pf)

   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

3. #### def exists(p: (A) ⇒ Boolean): Boolean

   Tests whether a predicate holds for at least one element of this iterable collection.

   Tests whether a predicate holds for at least one element of this iterable collection.

   Note: may not terminate for infinite-sized collections.

   p

     the predicate used to test elements.

   returns

     `false` if this iterable collection is empty, otherwise `true` if the given predicate `p` holds for some of the elements of this iterable collection, otherwise `false`

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).exists(p)

   Definition Classes
     IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

4. #### def filter(p: (A) ⇒ Boolean): collection.Iterable[A]

   Selects all elements of this iterable collection which satisfy a predicate.

   Selects all elements of this iterable collection which satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     a new iterable collection consisting of all elements of this iterable collection that satisfy the given predicate `p`. The order of the elements is preserved.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).filter(p)

   Definition Classes
     TraversableLike → GenTraversableLike

5. #### def filterNot(p: (A) ⇒ Boolean): collection.Iterable[A]

   Selects all elements of this iterable collection which do not satisfy a predicate.

   Selects all elements of this iterable collection which do not satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     a new iterable collection consisting of all elements of this iterable collection that do not satisfy the given predicate `p`. The order of the elements is preserved.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).filterNot(p)

   Definition Classes
     TraversableLike → GenTraversableLike

6. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): Option[B]

   [use case] Builds a new collection by applying a function to all elements of this option and using the elements of the resulting collections.

   [use case]

   Builds a new collection by applying a function to all elements of this option and using the elements of the resulting collections.

   For example:

       def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

   The type of the resulting collection is guided by the static type of option. This might cause unexpected results sometimes. For example:

       // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
       def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

       // lettersOf will return a Set[Char], not a Seq
       def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

       // xs will be an Iterable[Int]
       val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

       // ys will be a Map[Int, Int]
       val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

   B

     the element type of the returned collection.

   f

     the function to apply to each element.

   returns

     a new option resulting from applying the given collection-valued function `f` to each element of this option and concatenating the results.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).flatMap(f)

   Definition Classes
     TraversableLike → GenTraversableLike → FilterMonadic
   Full Signature

   #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

7. #### def flatten[B]: Option[B]

   [use case] Converts this option of traversable collections into a option formed by the elements of these traversable collections.

   [use case]

   Converts this option of traversable collections into a option formed by the elements of these traversable collections.

   The resulting collection's type will be guided by the static type of option. For example:

       val xs = List(
                  Set(1, 2, 3),
                  Set(1, 2, 3)
                ).flatten
       // xs == List(1, 2, 3, 1, 2, 3)

       val ys = Set(
                  List(1, 2, 3),
                  List(3, 2, 1)
                ).flatten
       // ys == Set(1, 2, 3)

   B

     the type of the elements of each traversable collection.

   returns

     a new option resulting from concatenating all element options.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).flatten

   Definition Classes
     GenericTraversableTemplate
   Full Signature

   #### def flatten[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): collection.Iterable[B]

8. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

   Folds the elements of this iterable collection using the specified associative binary operator.

   Folds the elements of this iterable collection using the specified associative binary operator.

   The order in which operations are performed on elements is unspecified and may be nondeterministic.

   Note: will not terminate for infinite-sized collections.

   A1

     a type parameter for the binary operator, a supertype of `A`.

   z

     a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication).

   op

     a binary operator that must be associative.

   returns

     the result of applying the fold operator `op` between all the elements and `z`, or `z` if this iterable collection is empty.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).fold(z)(op)

   Definition Classes
     TraversableOnce → GenTraversableOnce

9. #### def forall(p: (A) ⇒ Boolean): Boolean

   Tests whether a predicate holds for all elements of this iterable collection.

   Tests whether a predicate holds for all elements of this iterable collection.

   Note: may not terminate for infinite-sized collections.

   p

     the predicate used to test elements.

   returns

     `true` if this iterable collection is empty or the given predicate `p` holds for all elements of this iterable collection, otherwise `false`.

   Implicit information
     This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (option: Iterable[A]).forall(p)

   Definition Classes
     IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

10. #### def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this option.

    [use case]

    Applies a function `f` to all elements of this option.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).foreach(f)

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Full Signature

    #### def foreach[U](f: (A) ⇒ U): Unit

11. #### def isEmpty: Boolean

    Tests whether this iterable collection is empty.

    Tests whether this iterable collection is empty.

    returns

      `true` if the iterable collection contain no elements, `false` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).isEmpty

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

12. #### def iterator: collection.Iterator[A]

    Creates a new iterator over all elements contained in this iterable object.

    Creates a new iterator over all elements contained in this iterable object.

    returns

      the new iterator

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).iterator

    Definition Classes
      IterableLike → GenIterableLike

13. #### def map[B](f: (A) ⇒ B): Option[B]

    [use case] Builds a new collection by applying a function to all elements of this option.

    [use case]

    Builds a new collection by applying a function to all elements of this option.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new option resulting from applying the given function `f` to each element of this option and collecting the results.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).map(f)

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[collection.Iterable[A], B, That]): That

14. #### def nonEmpty: Boolean

    Tests whether the iterable collection is not empty.

    Tests whether the iterable collection is not empty.

    returns

      `true` if the iterable collection contains at least one element, `false` otherwise.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).nonEmpty

    Definition Classes
      TraversableOnce → GenTraversableOnce

15. #### def toList: List[A]

    Converts this iterable collection to a list.

    Converts this iterable collection to a list.

    Note: will not terminate for infinite-sized collections.

    returns

      a list containing all elements of this iterable collection.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).toList

    Definition Classes
      TraversableOnce → GenTraversableOnce

16. #### def toString(): String

    Converts this iterable collection to a string.

    Converts this iterable collection to a string.

    returns

      a string representation of this collection. By default this string consists of the `stringPrefix` of this iterable collection, followed by all elements separated by commas and enclosed in parentheses.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).toString()

    Definition Classes
      TraversableLike → Any

17. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, collection.Iterable[A]]

    Creates a non-strict filter of this iterable collection.

    Creates a non-strict filter of this iterable collection.

    Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this iterable collection which satisfy the predicate `p`.

    Implicit information
      This member is added by an implicit conversion from Option[A] to Iterable[A] performed by method option2Iterable in scala.Option.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (option: Iterable[A]).withFilter(p)

    Definition Classes
      TraversableLike → FilterMonadic

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion option2Iterable from Option[A] to Iterable[A]

### Inherited by implicit conversion any2stringadd from Option[A] to any2stringadd[Option[A]]

### Inherited by implicit conversion StringFormat from Option[A] to StringFormat[Option[A]]

### Inherited by implicit conversion Ensuring from Option[A] to Ensuring[Option[A]]

### Inherited by implicit conversion ArrowAssoc from Option[A] to ArrowAssoc[Option[A]]

### Ungrouped